package calistay;

import java.io.FileInputStream;
import java.util.Hashtable;

import junit.framework.TestCase;
import tr.gov.tubitak.uekae.esya.api.certificate.validation.policy.PolicyReader;
import tr.gov.tubitak.uekae.esya.api.certificate.validation.policy.ValidationPolicy;
import tr.gov.tubitak.uekae.esya.api.cmssignature.ISignable;
import tr.gov.tubitak.uekae.esya.api.cmssignature.attribute.EParameters;
import tr.gov.tubitak.uekae.esya.api.cmssignature.validation.SignedDataValidation;
import tr.gov.tubitak.uekae.esya.api.cmssignature.validation.SignedDataValidationResult;
import tr.gov.tubitak.uekae.esya.api.cmssignature.validation.SignedData_Status;
import tr.gov.tubitak.uekae.esya.asn.util.AsnIO;

public class ImzaDogrulama extends TestCase
{
	public void testImzaDogrula()throws Exception
	{
		ISignable externalContent = null;
		
		Hashtable<String, Object> params = new Hashtable<String, Object>();

		params.put(EParameters.P_CERT_VALIDATION_POLICY, getPolicy());
		if(externalContent != null)
			params.put(EParameters.P_EXTERNAL_CONTENT, externalContent);

		SignedDataValidation sdv = new SignedDataValidation();
		SignedDataValidationResult sdvr = sdv.verify(getSign(), params);

		//System.out.println(sdvr);
		
		SignedData_Status status = sdvr.getSDStatus();
		
		if(status == SignedData_Status.ALL_VALID)
			System.out.println("HEPSİ DOĞRULANDI");
		else
			System.out.println("EN AZ BİR TANESİ DOĞRULANAMADI");	

	}

	private byte[] getSign() throws Exception
	{
		return AsnIO.dosyadanOKU("testdata/ImzaEklendi.p7s");
	}

	private ValidationPolicy getPolicy() throws Exception
	{
		return PolicyReader.readValidationPolicy(new FileInputStream("örnek politika/policy.xml"));
	}
}
